/*
Dataddo Headless BETA API

Dataddo Headless BETA API

API version: 1.0.0-beta.1
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package customer_api

import (
	"encoding/json"
)

// checks if the AppAuthorizerGoogleAnalyticsCustomGoogleAnalyticsCustomAuthorizerNewOAuthCallbackRequest type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &AppAuthorizerGoogleAnalyticsCustomGoogleAnalyticsCustomAuthorizerNewOAuthCallbackRequest{}

// AppAuthorizerGoogleAnalyticsCustomGoogleAnalyticsCustomAuthorizerNewOAuthCallbackRequest struct for AppAuthorizerGoogleAnalyticsCustomGoogleAnalyticsCustomAuthorizerNewOAuthCallbackRequest
type AppAuthorizerGoogleAnalyticsCustomGoogleAnalyticsCustomAuthorizerNewOAuthCallbackRequest struct {
	CallbackUrl *string                             `json:"callbackUrl,omitempty"`
	Config      *GoogleAnalyticsCustomDtoAuthorizer `json:"config,omitempty"`
}

// NewAppAuthorizerGoogleAnalyticsCustomGoogleAnalyticsCustomAuthorizerNewOAuthCallbackRequest instantiates a new AppAuthorizerGoogleAnalyticsCustomGoogleAnalyticsCustomAuthorizerNewOAuthCallbackRequest object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewAppAuthorizerGoogleAnalyticsCustomGoogleAnalyticsCustomAuthorizerNewOAuthCallbackRequest() *AppAuthorizerGoogleAnalyticsCustomGoogleAnalyticsCustomAuthorizerNewOAuthCallbackRequest {
	this := AppAuthorizerGoogleAnalyticsCustomGoogleAnalyticsCustomAuthorizerNewOAuthCallbackRequest{}
	var callbackUrl string = "https://my.app.com/callback?code=aaaaBBBBccc1234"
	this.CallbackUrl = &callbackUrl
	return &this
}

// NewAppAuthorizerGoogleAnalyticsCustomGoogleAnalyticsCustomAuthorizerNewOAuthCallbackRequestWithDefaults instantiates a new AppAuthorizerGoogleAnalyticsCustomGoogleAnalyticsCustomAuthorizerNewOAuthCallbackRequest object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewAppAuthorizerGoogleAnalyticsCustomGoogleAnalyticsCustomAuthorizerNewOAuthCallbackRequestWithDefaults() *AppAuthorizerGoogleAnalyticsCustomGoogleAnalyticsCustomAuthorizerNewOAuthCallbackRequest {
	this := AppAuthorizerGoogleAnalyticsCustomGoogleAnalyticsCustomAuthorizerNewOAuthCallbackRequest{}
	var callbackUrl string = "https://my.app.com/callback?code=aaaaBBBBccc1234"
	this.CallbackUrl = &callbackUrl
	return &this
}

// GetCallbackUrl returns the CallbackUrl field value if set, zero value otherwise.
func (o *AppAuthorizerGoogleAnalyticsCustomGoogleAnalyticsCustomAuthorizerNewOAuthCallbackRequest) GetCallbackUrl() string {
	if o == nil || IsNil(o.CallbackUrl) {
		var ret string
		return ret
	}
	return *o.CallbackUrl
}

// GetCallbackUrlOk returns a tuple with the CallbackUrl field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *AppAuthorizerGoogleAnalyticsCustomGoogleAnalyticsCustomAuthorizerNewOAuthCallbackRequest) GetCallbackUrlOk() (*string, bool) {
	if o == nil || IsNil(o.CallbackUrl) {
		return nil, false
	}
	return o.CallbackUrl, true
}

// HasCallbackUrl returns a boolean if a field has been set.
func (o *AppAuthorizerGoogleAnalyticsCustomGoogleAnalyticsCustomAuthorizerNewOAuthCallbackRequest) HasCallbackUrl() bool {
	if o != nil && !IsNil(o.CallbackUrl) {
		return true
	}

	return false
}

// SetCallbackUrl gets a reference to the given string and assigns it to the CallbackUrl field.
func (o *AppAuthorizerGoogleAnalyticsCustomGoogleAnalyticsCustomAuthorizerNewOAuthCallbackRequest) SetCallbackUrl(v string) {
	o.CallbackUrl = &v
}

// GetConfig returns the Config field value if set, zero value otherwise.
func (o *AppAuthorizerGoogleAnalyticsCustomGoogleAnalyticsCustomAuthorizerNewOAuthCallbackRequest) GetConfig() GoogleAnalyticsCustomDtoAuthorizer {
	if o == nil || IsNil(o.Config) {
		var ret GoogleAnalyticsCustomDtoAuthorizer
		return ret
	}
	return *o.Config
}

// GetConfigOk returns a tuple with the Config field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *AppAuthorizerGoogleAnalyticsCustomGoogleAnalyticsCustomAuthorizerNewOAuthCallbackRequest) GetConfigOk() (*GoogleAnalyticsCustomDtoAuthorizer, bool) {
	if o == nil || IsNil(o.Config) {
		return nil, false
	}
	return o.Config, true
}

// HasConfig returns a boolean if a field has been set.
func (o *AppAuthorizerGoogleAnalyticsCustomGoogleAnalyticsCustomAuthorizerNewOAuthCallbackRequest) HasConfig() bool {
	if o != nil && !IsNil(o.Config) {
		return true
	}

	return false
}

// SetConfig gets a reference to the given GoogleAnalyticsCustomDtoAuthorizer and assigns it to the Config field.
func (o *AppAuthorizerGoogleAnalyticsCustomGoogleAnalyticsCustomAuthorizerNewOAuthCallbackRequest) SetConfig(v GoogleAnalyticsCustomDtoAuthorizer) {
	o.Config = &v
}

func (o AppAuthorizerGoogleAnalyticsCustomGoogleAnalyticsCustomAuthorizerNewOAuthCallbackRequest) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o AppAuthorizerGoogleAnalyticsCustomGoogleAnalyticsCustomAuthorizerNewOAuthCallbackRequest) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.CallbackUrl) {
		toSerialize["callbackUrl"] = o.CallbackUrl
	}
	if !IsNil(o.Config) {
		toSerialize["config"] = o.Config
	}
	return toSerialize, nil
}

type NullableAppAuthorizerGoogleAnalyticsCustomGoogleAnalyticsCustomAuthorizerNewOAuthCallbackRequest struct {
	value *AppAuthorizerGoogleAnalyticsCustomGoogleAnalyticsCustomAuthorizerNewOAuthCallbackRequest
	isSet bool
}

func (v NullableAppAuthorizerGoogleAnalyticsCustomGoogleAnalyticsCustomAuthorizerNewOAuthCallbackRequest) Get() *AppAuthorizerGoogleAnalyticsCustomGoogleAnalyticsCustomAuthorizerNewOAuthCallbackRequest {
	return v.value
}

func (v *NullableAppAuthorizerGoogleAnalyticsCustomGoogleAnalyticsCustomAuthorizerNewOAuthCallbackRequest) Set(val *AppAuthorizerGoogleAnalyticsCustomGoogleAnalyticsCustomAuthorizerNewOAuthCallbackRequest) {
	v.value = val
	v.isSet = true
}

func (v NullableAppAuthorizerGoogleAnalyticsCustomGoogleAnalyticsCustomAuthorizerNewOAuthCallbackRequest) IsSet() bool {
	return v.isSet
}

func (v *NullableAppAuthorizerGoogleAnalyticsCustomGoogleAnalyticsCustomAuthorizerNewOAuthCallbackRequest) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableAppAuthorizerGoogleAnalyticsCustomGoogleAnalyticsCustomAuthorizerNewOAuthCallbackRequest(val *AppAuthorizerGoogleAnalyticsCustomGoogleAnalyticsCustomAuthorizerNewOAuthCallbackRequest) *NullableAppAuthorizerGoogleAnalyticsCustomGoogleAnalyticsCustomAuthorizerNewOAuthCallbackRequest {
	return &NullableAppAuthorizerGoogleAnalyticsCustomGoogleAnalyticsCustomAuthorizerNewOAuthCallbackRequest{value: val, isSet: true}
}

func (v NullableAppAuthorizerGoogleAnalyticsCustomGoogleAnalyticsCustomAuthorizerNewOAuthCallbackRequest) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableAppAuthorizerGoogleAnalyticsCustomGoogleAnalyticsCustomAuthorizerNewOAuthCallbackRequest) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
